#
# Barpanel "Static Menu" plugin
# 
# Copyright (C) 2008 Job and Esther Technologies Ltd
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#

name = "Static Menu"
description = """Static Menu."""

import barpanel, gtk, gobject, os

class item(gtk.Button):
    def __init__(self, panel, plugin, icon, alabel, description, command, menuwindow):
        self.command = command
        self.menuwindow = menuwindow
        gtk.Button.__init__(self)
        self.set_relief(gtk.RELIEF_NONE)
        cont = gtk.HBox(False, 10)
        cont.set_border_width(3)
        cont.show()
        self.add(cont)
        try:
            if icon[0] == '/' and os.path.exists(icon):
                image = panel.get_image_from_file(icon, 24)
            else:
                image = panel.get_image_from_icon_name(icon, 24)
        except Exception, msg:
            image = panel.get_image_from_stock(gtk.STOCK_EXECUTE, 24)
        image.show()
        cont.pack_start(image, False, False)
        label = gtk.Label()
        label.show()
        label.set_property("xalign", 0)
        label.set_markup("<b>%s</b>\n%s" % (alabel, description))
        cont.pack_start(label, True, True)
        self.connect("button-release-event", self.cb_clicked)

    def cb_clicked(self, entry, event):
        self.menuwindow.toggle()
        barpanel.launch_command(self.command)

class Plugin(barpanel.Plugin):
    def __init__(self, panel, settings):
        barpanel.Plugin.__init__(self, panel, settings)
        btn = gtk.ToggleButton()
        btn.set_name("EdgeButton")
        btn.connect("toggled", self.onToggled)
        btn.set_relief(gtk.RELIEF_NONE)
        if settings.has_key('desc') and settings['desc'] != None and len(settings['desc'])>0:
            barpanel.tooltips.set_tip(btn, settings['desc'])
        elif settings.has_key('label') and settings['label'] != None and len(settings['label'])>0:
            barpanel.tooltips.set_tip(btn, settings['label'])
        else:
            barpanel.tooltips.set_tip(btn, "Options menu")
        self.add(btn)
        box = gtk.HBox(False, 2)
        btn.add(box)
        img = panel.get_image_from_icon_name(settings['icon'])
        box.add(img)
        if settings['label'] != None and len(settings['label'])>0:
            lbl = gtk.Label(settings['label'])
            panel.update_font(self, lbl)
            box.add(lbl)
        self.menuwindow = barpanel.BarpanelMenuWindow(settings['name'], settings['desc'], \
                                                          panel.get_image_from_icon_name(settings['icon'], 24), \
                                                          panel)
        btn.connect("enter-notify-event", self.menuwindow.toggleConditional)
        x = 1
        while True:
            try:
                citem = settings["item%d" % (x)]
                icon = citem['icon']
                label = citem['label']
                desc = citem['desc']
                command = citem['command']
                if icon!=None and label!=None and command!=None:
                    self.menuwindow.append(item(panel, self, icon, label, desc, command, self.menuwindow))
            except:
                break
            x = x + 1

        self.show_all()

    def onToggled(self, btn):
        self.menuwindow.toggle(btn)
